package org.test;

import java.io.IOException;
import java.net.URI;
import java.nio.channels.SeekableByteChannel;
import java.nio.file.*;
import java.nio.file.attribute.*;
import java.nio.file.DirectoryStream.Filter;
import java.nio.file.spi.FileSystemProvider;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Test {
	
	public static void main(String [] args) {
		System.out.println(FileSystems.getDefault());
	}
	
}

class TestProvider extends FileSystemProvider {
    private final FileSystemProvider priorProvider;
    private static final String scheme = "file";
    
    /**
     * This may be used as a 'helper' provider for attributes or whatever
     * so the no arg constructor may be used and simply sets priorProvider to the 
     * first found 'file' scheme provider - which should be the 'default' platform
     * provider.
     */
    public TestProvider() {
    	List<FileSystemProvider> providers = FileSystemProvider.installedProviders();
    	for (FileSystemProvider provider : providers) {
    		if (provider.getScheme().equals(scheme)) {
    			priorProvider = provider;
    			return;
    		}
    	}
    	// Hopefully, shouldn't happen
    	priorProvider = null; 
    }
	
    public TestProvider(FileSystemProvider fsp) { 
    	priorProvider = fsp; 
    }
	
    /**
     * Splits the given attribute name into the name of an attribute view and
     * the attribute. If the attribute view is not identified then it assumed
     * to be "basic".
     */
    private static String[] split(String attribute) {
        String[] s = new String[2];
        int pos = attribute.indexOf(':');
        if (pos == -1) {
            s[0] = "basic";
            s[1] = attribute;
        } else {
            s[0] = attribute.substring(0, pos++);
            s[1] = (pos == attribute.length()) ? "" : attribute.substring(pos);
        }
        return s;
    }
    
    @Override
    public void setAttribute(Path path, String attribute,
                             Object value, LinkOption... options)
        throws IOException
    {
        String[] s = split(attribute);
        if (s[0].length() == 0)
            throw new IllegalArgumentException(attribute);
    }
    
    @Override
    public <A extends BasicFileAttributes> A
        readAttributes(Path path, Class<A> type, LinkOption... options)
        throws IOException
    {
        return null;
    }
 
    @Override
    public Map<String, Object>
        readAttributes(Path path, String attributes, LinkOption... options)
        throws IOException
    {
		return null;
    }
    
    @Override
    @SuppressWarnings("unchecked")
    public <V extends FileAttributeView> V
        getFileAttributeView(Path path, Class<V> type, LinkOption... options)
    {
 		return null;
    }
    
    protected FileAttributeView getFileAttributeView(Path obj,
                                                            String name,
                                                            LinkOption... options)
    {
        return null;
    }
    
    boolean followLinks(LinkOption... options) {
        boolean followLinks = true;
        return followLinks;
    }
    
    @Override
    public void checkAccess(Path path, AccessMode... modes) throws IOException {
    }
    
    @Override
    public FileStore getFileStore(Path path) throws IOException {
    	return priorProvider.getFileStore(path);
    }
    
    @Override
    public boolean isHidden(Path path) throws IOException {
        return priorProvider.isHidden(path);
    }
    
    @Override
    public boolean isSameFile(Path path, Path other) throws IOException {
        return priorProvider.isSameFile(path,other);
    }
    
    @Override
    public void move(Path src, Path target, CopyOption... options)
        throws IOException
    {
    }
    
    @Override
    public void copy(Path src, Path target, CopyOption... options)
        throws IOException
    {
    }
    
    @Override
    public final void delete(Path path) throws IOException {
    }
    
    @Override
    public void createDirectory(Path path, FileAttribute<?>... attrs)
        throws IOException
    {
    }
    
    @Override
    public DirectoryStream<Path> newDirectoryStream(
        Path path, Filter<? super Path> filter) throws IOException
    {
		return null;
    }
    
     @Override
    public SeekableByteChannel newByteChannel(Path path,
                                              Set<? extends OpenOption> options,
                                              FileAttribute<?>... attrs)
        throws IOException
    {
 		return null;
    }
    
    @Override
    public Path getPath(URI uri) {
		return priorProvider.getPath(uri);
    }

    @Override
    public FileSystem getFileSystem(URI uri) {
 		return null;
    }
    
    @Override
    public FileSystem newFileSystem(URI uri, Map<String, ?> env)
        throws IOException
    {
       return null;
    }
    
    @Override
    public String getScheme() {
       return "file";
    }
}

